<template>
  <div class="w-full w-full">
    <l-map style="height: 400px; width: 100% !important;" :zoom="zoom" :center="center" @click="addMarker">
      <l-tile-layer :url="url" :attribution="attribution"></l-tile-layer>
      <l-markers
          v-if="values.from"
          :marker="fromMarker"
          :draggable="true"
          @dragend="e => moveMarker(e,'from')"
      />
      <l-markers
          v-if="values.to"
          :marker="toMarker"
          :draggable="true"
          @dragend="e => moveMarker(e,'to')"
      />
    </l-map>
  </div>
</template>

<script>
import LMarkers from "@/components/Leaflet/LMarkers.vue"
import {LMap, LTileLayer} from "vue2-leaflet"
import "leaflet/dist/leaflet.css"

export default {
  name: "MapChoosePoints",
  inject: ["values"],
  data: () => ({
    url: "https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png",
    attribution:
        '&copy; <a target="_blank" href="http://osm.org/copyright">OpenStreetMap</a> contributors',
    zoom: 6,
    center: [47.53092519322762, 2.3734923973713276],
  }),
  components: {
    LMarkers,
    LMap,
    LTileLayer
  },
  computed: {
    fromMarker() {
      return {
        id: "A",
        coordinates: this.values.from.split(",").map(n => parseFloat(n.trim())),
        color: "grey",
        popup: "Départ"+(this.values.cityA !== "" ? " ("+this.values.cityA+")" : "")
      }
    },
    toMarker() {
      return {
        id: "A",
        coordinates: this.values.to.split(",").map(n => parseFloat(n.trim())),
        color: "grey",
        popup: "Arrivée"+(this.values.cityB !== "" ? " ("+this.values.cityB+")" : "")
      }
    }
  },
  methods: {
    moveMarker({target: {_latlng: {lat,lng}}}, toUpdate) {
      this.values[toUpdate] = lat+","+lng;
      this.values["city"+(toUpdate === "from" ? "A" : "B")] = "";
      this.values["codeCommune"+(toUpdate === "from" ? "A" : "B")] = null;
    },
    addMarker({latlng: {lat, lng}}) {
      if (this.values.from === null) {
        this.values.from = lat + "," + lng;
        this.values.cityA = "";
        this.values.codeCommuneA = null;
      } else if (this.values.to === null) {
        this.values.to = lat + "," + lng;
        this.values.cityB = "";
        this.values.codeCommuneB = null;
      }
    }
  }
}
</script>